package codemaptournament;

import java.util.Comparator;
import org.apache.commons.collections.comparators.ComparatorChain;

/**
 *
 * @author Paul
 */
public class MedalCountEntry {
    public int goldCount = 0;
    public int silverCount = 0;
    public int bronzeCount = 0;
    public final String playerName;

    public MedalCountEntry(String playerName) {
        this.playerName = playerName;
    }

    public int calcScore() {
        return goldCount * 4 + silverCount * 2 + bronzeCount;
    }

    static class CompareByUser implements Comparator<MedalCountEntry> {

        public int compare(MedalCountEntry o1, MedalCountEntry o2) {
            return o1.playerName.compareToIgnoreCase(o2.playerName);
        }
    }

    static class CompareByScore implements Comparator<MedalCountEntry> {

        public int compare(MedalCountEntry o1, MedalCountEntry o2) {
            return o1.calcScore() - o2.calcScore();
        }
    }

    public static final Comparator tournamentComparator;

    static {
        ComparatorChain c = new ComparatorChain();
        c.addComparator(new MedalCountEntry.CompareByScore(), true); // high first
        c.addComparator(new MedalCountEntry.CompareByUser(), false); // low first
        tournamentComparator = c;
    }
}
