package codemaptournament;

import java.util.List;
import javax.swing.table.AbstractTableModel;

/**
 * Display missions in a table whit no fancy stuff.
 * 3 columns: code, size, complexity.
 * @author Paul
 */
public class SimpleMissionTableModel extends AbstractTableModel {

    private List<Mission> missionList;

    public void setMissionList(List<Mission> missionList) {
        this.missionList = missionList;
        fireTableDataChanged();
    }

    public int getRowCount() {
        if (missionList == null) {
            return 5;
        }
        return missionList.size();
    }

    public int getColumnCount() {
        return 3;
    }

    @Override
    public Class<?> getColumnClass(int columnIndex) {
        return String.class;
    }

    public Object getValueAt(int rowIndex, int columnIndex) {
        if (missionList == null) {
            return null;
        }
        final Mission m = missionList.get(rowIndex);
        switch (columnIndex) {
            case 0:
                return m.code;
            case 1:
                return Mission.sizeStrings[m.size];
            case 2:
                return Mission.complexityStrings[m.complexity];
        }
        throw new IllegalArgumentException("column index out of bounds");
    }
}
