package codemaptournament;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 *
 * @author Paul
 */
public class WikiTournamentRankings {
    Map<String, MedalCountEntry> medalCountsOfPlayer = new HashMap<String, MedalCountEntry>();
    public void accumulate(WikiTournamentRecord wtr) {
        checkAddPlayer(wtr.goldPlayer);
        medalCountsOfPlayer.get(wtr.goldPlayer).goldCount++;
        checkAddPlayer(wtr.silverPlayer);
        medalCountsOfPlayer.get(wtr.silverPlayer).silverCount++;
        checkAddPlayer(wtr.bronzePlayer);
        medalCountsOfPlayer.get(wtr.bronzePlayer).bronzeCount++;
    }

    public List<MedalCountEntry> getTournamentRankings() {
        List<MedalCountEntry> entries = new ArrayList<MedalCountEntry>(medalCountsOfPlayer.values());
        Collections.sort(entries, MedalCountEntry.tournamentComparator);
        return entries;
    }


    private void checkAddPlayer(String player) {
        if (!medalCountsOfPlayer.containsKey(player))
            medalCountsOfPlayer.put(player, new MedalCountEntry(player));
    }
}
