package codemaptournament;

import java.util.regex.Matcher;

/**
 *
 * @author Paul
 */
public class WikiTournamentRecord {
    public final Integer number;
    public final String theme;
    public final String goldPlayer;
    public final String silverPlayer;
    public final String bronzePlayer;
    public final Integer goldScore;
    public final Integer silverScore;
    public final Integer bronzeScore;

    private static final int IDX_N = 1;
    private static final int IDX_T = 2;
    private static final int IDX_GP = 3;
    private static final int IDX_SP = 4;
    private static final int IDX_BP = 5;
    private static final int IDX_GS = 6;
    private static final int IDX_SS = 7;
    private static final int IDX_BS = 8;
    public static final int NUM_DATA = 8;
    private static Integer parseOrNull(String s) {
        if (s == null || s.isEmpty()) return null;
        return Integer.parseInt(s);
    }
    public WikiTournamentRecord(Matcher m) {
        assert(m.groupCount() == NUM_DATA);
        number = parseOrNull(m.group(IDX_N));
        theme = m.group(IDX_T);
        goldPlayer = m.group(IDX_GP);
        silverPlayer = m.group(IDX_SP);
        bronzePlayer = m.group(IDX_BP);
        goldScore = parseOrNull(m.group(IDX_GS));
        silverScore = parseOrNull(m.group(IDX_SS));
        bronzeScore = parseOrNull(m.group(IDX_BS));
    }
}
